import React, {Fragment} from 'react'
import { Form, Radio, Select } from 'antd'
import './ItemRadioSelect.scss'
const Option = Select.Option;
const RadioGroup = Radio.Group;
export default class ItemRadioSelect extends React.Component{
  constructor(props){
    super(props);
    this.state = {
      disabled: true,
    }
  }
  onChange = (e) => {
    if(e.target.value ===1 ){
      this.setState({
        disabled: true,
      })
    }else {
      this.setState({
        disabled: false,
      })
    }
    this.setState({
      value: e.target.value,
    });
  };
  componentDidMount() {
    if(this.props.dataSource[this.props.item.key.radio].initialValue < 1){
      this.setState({
        disabled:false,
      })
    }
  }
  componentWillReceiveProps(nextProps, nextContext) {
    if(nextProps.dataSource[this.props.item.key.radio].initialValue > 0){
      this.setState({
        disabled:true,
      })
    }

  }

  render() {
    const { getFieldDecorator } = this.props.form;
    return (
      <Fragment>
        <Form.Item label={
          <span>
            <i className={'iconfont '+ this.props.item.transfer}></i>
            {this.props.item.label.radio}
          </span>
        } {...this.props.formItemLayout}>
        {getFieldDecorator(this.props.item.key.radio, {
          initialValue: this.props.dataSource[this.props.item.key.radio]?this.props.dataSource[this.props.item.key.radio].initialValue:null,
          rules: [
            {
              required: this.props.item.required,
              message: '必须',
            },
          ],
        })(
          <RadioGroup  onChange={this.onChange}>
            <Radio value={1}>是</Radio>
            <Radio value={0}>否</Radio>
          </RadioGroup>
        )}
        </Form.Item>
        <Form.Item label={this.props.item.label.select} {...this.props.formItemLayout}>
        {getFieldDecorator(this.props.item.key.select, {
          initialValue: this.props.dataSource[this.props.item.key.select].initialValue?this.props.dataSource[this.props.item.key.select].initialValue:[],
          rules: [
            {
              required: this.state.disabled,
              message: '必须',
            },
          ],
        })(
          <Select disabled={!this.state.disabled} style={{ width: 120 }} onChange={this.handleChange}>
            {
              this.props.item.data.select.map((item,i)=> {
                return <Option value={item.id}>{item.name}</Option>
              })
            }
          </Select>
        )}
        </Form.Item>
      </Fragment>
    );
  }
}
