import React,{Fragment} from 'react';
import { Modal } from 'antd';
import ItemForm from '../ItemForm'
export default class ItemModal extends React.Component{
  constructor(props){
    super(props);
    this.state = {
      visible: false,
      dataSource:{},
      config:[],
    };
    this.modalConfirm = React.createRef();
  }
  modalConfirm;
  showModal = () => {
    this.setState({
      visible: true,
    });
  };

  handleOk = (e) => {
    this.modalConfirm.handleSubmit(e);
    if(this.props.config && this.props.config.autoClose){
      this.handleCancel();
    }
  };
  handleCancel = () => {
    this.setState({
      visible: false,
    });
    this.modalConfirm.handleReset();
  };
  getReqParams=(values,err)=>{
    if(!err){
      this.props.config.getOutput(values)
    }
  }
  componentWillReceiveProps(nextProps, nextContext) {
    this.setState({
      dataSource:nextProps.config.dataSource,
      config:nextProps.config.render
    })
  }

  render() {
    const { visible, confirmLoading } = this.state;
    return(
      <div>
        <Modal
          title={this.props.config.title}
          visible={visible}
          onOk={this.handleOk}
          onCancel={this.handleCancel}
        >
          <div>
            <ItemForm wrappedComponentRef={r => this.modalConfirm = r} dataSource={this.state.dataSource}  config={this.state.config} getReqParams={this.getReqParams}/>
          </div>
        </Modal>
      </div>
    )
  }
}
